#
# $Id: mcDebug.pm,v 1.2 2002/03/10 19:37:31 mcooper Exp $
#
# Debug SysInfo functions
#

package mcDebug;
require 5.003;
require Exporter;

use mcGlobals;

$Debug = undef;
$ProgramName = undef;
my $MsgFunc;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   Debug DebugToggle
		   $Debug
		  );
}

#
# Debug
#
sub Debug {
    my $Arg = shift;
    my $fmt = $Arg;

    if (ref($Arg) eq 'HASH') {
	# Set $Debug flag
	if (defined($Arg->{Debug})) {
	    $Debug = $Arg->{Debug};
	}
	if (defined($Arg->{Func})) {
	    $MsgFunc = $Arg->{Func};
	}
	return;
    }

    if (!$Debug) {
	return;
    }

    if ($fmt !~ /\n/) {
	$fmt = $fmt . "\n";
    }
    my $Str = sprintf($fmt, @_);

    printf STDERR $Str;

    if ($MsgFunc) {
	&$MsgFunc($Str);
    }
}

#
# Toggle $Debug
#
sub DebugToggle {
    Debug("DebugToggle Current=%d", $Debug);

    if ($Debug) {
	$Debug = 0;
    } else {
	$Debug = 1;
    }
}

1; # Make require/use happy
