#
# $Id: mcHardware.pm,v 1.5 2001/06/02 20:14:19 mcooper Exp $
#
# Hardware object
#

package mcHardware;
require 5.003;

use mcMisc;
use mcDevInfo;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Entries"} = undef;

    bless ($self, $class);

    return $self;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Decode an array of DevInfo fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "device")) {
	return;
    }

    my $DevName = $Fields[2];
    if (Eq($Fields[1], 'totaldisk')) {
	$DevName = 'TOTAL DISK';
    }

    my $DevInfo = mcDevInfo->New;
    # Lookup the DevInfo entry (if any)
    my $di = $self->Entries($DevName);
    if (!$di) {
	# Need a new object
	$di = $DevInfo;
    }
    # Decode and Set
    $di->Decode(@Fields);
    # Add it back
    $self->Entries({$DevName => $di});

    return $self;
}

1; # Make require/use happy
